/* @(#) $Id: HtmlDigitalSignatureForm.js,v 1.12 2008/05/08 01:55:51 subrata Exp $ */

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is  Avaya Labs Research, Avaya Inc. Code.
 *
 * The Initial Developer of the Original Code is
 *     Subrata Mazumdar, Avaya Labs Research, Avaya Inc.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Subrata Mazumdar (mazum@avaya.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



/*
var gHtmlInputOptionGroupElem;
var gHtmlInputFileOptionElem;
var gHtmlInputURIOptionElem;
*/
var gHtmlInputSourceGroupElem;
var gHtmlInputFilePickerElem;
var gHtmlInputRefURIUsePathElem;
var gHtmlInputRefURIElem;


var gHtmlInputFileURIHboxElem;
var gHtmlInputFileURIElem;
var gHtmlInputDocURIElem;

var gHtmlDSigInputFileIsSignedElem;
var gHtmlDSigResignRowElem;
var gHtmlDSigSignCmdElem;
var gHtmlDSigOutAutoSelectElem;
var gHtmlDSigProfileTypeMenuElem;

var gHtmlDSigEditorGBoxElem;
var gHtmlDSigEditorElem;

var gHtmlDSigSignedOutDocGridElem;

var gHtmlDSigXmlOutFilePickerRowElem;
var gHtmlDSigXmlOutFilePickerElem;
var gHtmlDSigXmlOutFileVerifyElem;

var gHtmlDSigHtmlOutFilePickerRowElem;
var gHtmlDSigHtmlOutFilePickerElem;
var gHtmlDSigHtmlOutFileVerifyElem;

var gHtmlDSigEnableEncryptRowElem;

// var gXmlParser;
// var gXmlSerializer;

function xmldsigffext_htmldsig_initFormXULElems()
{
    // dump("xmldsigffext_htmldsig_initFormXULElems():................Start.\n");



    /*
    gHtmlInputOptionGroupElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.options");
    gHtmlInputFileOptionElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.option");
    gHtmlInputURIOptionElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.uri.option");
    */
    gHtmlInputSourceGroupElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.source");
    gHtmlInputFilePickerElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.path");
    gHtmlInputRefURIUsePathElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.refuri.usefile");
    gHtmlInputRefURIElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.refuri");

    gHtmlInputFileURIHboxElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.uri.hbox");
    gHtmlInputFileURIElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.uri");

    gHtmlInputDocURIElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.doc.uri");

    gHtmlDSigInputFileIsSignedElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.uri.issigned");
    /*
    gHtmlDSigResignRowElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.cmd.sign.row");
    */
    gHtmlDSigSignCmdElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.cmd.sign");
    gHtmlDSigProfileTypeMenuElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.sigprofile.type.menu");
    gHtmlDSigOutAutoSelectElem		= document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.autoselect");


    gHtmlDSigEditorGBoxElem	= document.getElementById("xmldsigffext.htmldsig.form.xmlsig.gbox");
    gHtmlDSigEditorElem		= document.getElementById("xmldsigffext.htmldsig.form.signature.editor");

    gHtmlDSigSignedOutDocGridElem 	= document.getElementById("xmldsigffext.htmldsig.form.xmlsig.out.doc.grid"); 
    gHtmlDSigXmlOutFilePickerRowElem = document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.sigxmldoc.row"); 
    gHtmlDSigXmlOutFilePickerElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.sigxmldoc.path"); 
    gHtmlDSigXmlOutFileVerifyElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.sigxmldoc.verify"); 

    gHtmlDSigHtmlOutFilePickerRowElem = document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.htmldoc.row"); 
    gHtmlDSigHtmlOutFilePickerElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.htmldoc.path"); 
    gHtmlDSigHtmlOutFileVerifyElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.file.out.htmldoc.verify"); 

    xmldsigffext_htmldsig_initSignVerifySig();

    xmldsigffext_htmldsig_handleSignCmdChange(gHtmlDSigSignCmdElem);
    xmldsigffext_htmldsig_handleHtmlFilePickerChange(gHtmlInputFilePickerElem);
    xmldsigffext_htmldsig_handleHtmlFileSourceChange(gHtmlInputSourceGroupElem);
    

    // dump("xmldsigffext_htmldsig_initFormXULElems():................End.\n");
}

function xmldsigffext_htmldsig_resetInputFileSourceForm()
{

    gHtmlInputDocURIElem.value = "";

    gHtmlInputFileURIElem.value = "";

    gHtmlInputFilePickerElem.filepath = "";
    gHtmlInputRefURIElem.value = "";
    gHtmlInputRefURIUsePathElem.checked = false;
    xmldsigffext_htmldsig_handleHtmlFilePickerChange(gHtmlInputFilePickerElem);


    gHtmlDSigOutAutoSelectElem.checked = false;
    gHtmlDSigSignCmdElem.checked = false;
    xmldsigffext_htmldsig_handleSignCmdChange(gHtmlDSigSignCmdElem);
}


function xmldsigffext_htmldsig_initSignVerifySig()
{
    gHtmlDSigEditorGBoxElem.hidden = true;
}

function xmldsigffext_htmldsig_doOnloadInitSignParam(/* String */ inHtmlFileURI, /* String */ outXmlFilePath, /* nsIX509 */ aSelectedSignerCert)
{
    // dump("xmldsigffext_htmldsig_doOnloadInitSignParam():................Start.\n");

    /*
    dump("inHtmlFileURI: " + inHtmlFileURI + " " + 
    		"outXmlFilePath: " + outXmlFilePath + " " + 
    		"cert: " + (aSelectedSignerCert?aSelectedSignerCert.nickname:"") + " " + 
		"\n");
    */

    if (inHtmlFileURI) {
    	gHtmlInputFileURIElem.value = inHtmlFileURI;
	gHtmlInputFileURIElem.disabled = true;
    }


    if (aSelectedSignerCert) {
    	// xmldsigffext_htmldsig_setUserCredential(aSelectedSignerCert);
    }

    if (outXmlFilePath) {
    	gHtmlDSigXmlOutFilePickerElem.value = outXmlFilePath;
	gHtmlDSigXmlOutFilePickerElem.disabled = true;
    }

    xmldsigffext_htmldsig_handleHtmlFileURIChange(gHtmlInputFileURIElem);

    // dump("xmldsigffext_htmldsig_doOnloadInitSignParam():................End.\n");
}


function xmldsigffext_htmldsig_handleHtmlDocURIChange(aHtmlInputDocURIElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlDocURIChange():................Start.\n");

    gHtmlDSigEditorGBoxElem.hidden = true;
    gHtmlDSigSignedOutDocGridElem.hidden = true;


    gHtmlDSigXmlOutFilePickerElem.filepath = "";
    gHtmlDSigHtmlOutFilePickerElem.filepath = "";

    /*
    if (aHtmlInputDocURIElem.value != "") {
    	gHtmlDSigSignedOutDocGridElem.hidden = false;
    }
    */
    xmldsigffext_htmldsig_displayHtmlDocURI(aHtmlInputDocURIElem.value);

    // dump("xmldsigffext_htmldsig_handleHtmlDocURIChange():................End.\n");
}

function xmldsigffext_htmldsig_handleHtmlFileURIChange(aHtmlInputFileURIElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlFileURIChange():................Start.\n");

    var htmlInputFileURISpec = trimString(aHtmlInputFileURIElem.value);
    aHtmlInputFileURIElem.value = htmlInputFileURISpec;

    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService);
    var htmlInputFileURI = null;
    try {
    	htmlInputFileURI = ioService.newURI(htmlInputFileURISpec, null, null);
    } catch (ex) {
    	gHtmlInputDocURIElem.value = "";
    	alert("Invalid HTML Doc URL: " + htmlInputFileURISpec);
	return;
    }

    gHtmlDSigInputFileIsSignedElem.checked = false;
    gHtmlDSigInputFileIsSignedElem.hidden = true;

    var htmlInputFileVBoxElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.vbox"); 
    if (ev && (htmlInputFileURISpec != "")) {
    	gHtmlInputFilePickerElem.filepath = "";
    	htmlInputFileVBoxElem.hidden = true;
	gHtmlInputRefURIUsePathElem.hidden = true;
    }
    else {
    	htmlInputFileVBoxElem.hidden = false;
	gHtmlInputRefURIUsePathElem.hidden = false;
    }

    gHtmlInputDocURIElem.value = htmlInputFileURISpec;

    // dump("xmldsigffext_htmldsig_handleHtmlFileURIChange():................End.\n");
}

function xmldsigffext_htmldsig_handleHtmlFileRefURIChange(aHtmlInputRefURIElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlFileRefURIChange():................Start.\n");

    var htmlInputFileURI = trimString(aHtmlInputRefURIElem.value);
    aHtmlInputRefURIElem.value = htmlInputFileURI;

    if (aHtmlInputRefURIElem.value == "") {
    	return;
    }

    // dump("xmldsigffext_htmldsig_handleHtmlFileRefURIChange():................End.\n");
}

function xmldsigffext_htmldsig_handleHtmlFileAsURIChange(aHtmlDSigInputUseFileURIElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlFileAsURIChange():................Start.\n");

    if (!gHtmlInputFilePickerElem.file) {
    	return;
    }
    gHtmlInputRefURIElem.value = "";
    if (aHtmlDSigInputUseFileURIElem.checked) {
    	gHtmlInputRefURIElem.value = gHtmlInputFilePickerElem.fileuri;
	gHtmlInputRefURIElem.disabled = true;
    }
    else {
	gHtmlInputRefURIElem.disabled = false;
	/*
	if (ev) {
	    ev.stopPropagation();
	}
	*/
    }
    xmldsigffext_htmldsig_handleHtmlFileRefURIChange(gHtmlInputRefURIElem);

    // dump("xmldsigffext_htmldsig_handleHtmlFileAsURIChange():................End.\n");
}



function xmldsigffext_htmldsig_handleHtmlFilePickerChange(aHtmlInputFilePickerElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlFilePickerChange():................Start.\n");

    // New file, reset and hide signature status
    gHtmlDSigInputFileIsSignedElem.checked = false;
    gHtmlDSigInputFileIsSignedElem.hidden = true;

    gHtmlInputFileURIElem.value = "";
    gHtmlInputRefURIUsePathElem.checked = false;
   
    if (!aHtmlInputFilePickerElem.file) {
	gHtmlInputRefURIUsePathElem.hidden = true;
	return;
    }
    var htmlInputRefURIHboxElem = document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.refuri.hbox");
    htmlInputRefURIHboxElem.hidden = false;
    /*
    if (ev) {
    	gHtmlInputRefURIUsePathElem.checked = true;
    }
    */
    gHtmlInputRefURIUsePathElem.hidden = false;

    xmldsigffext_htmldsig_handleHtmlFileAsURIChange(gHtmlInputRefURIUsePathElem);

    // dump("xmldsigffext_htmldsig_handleHtmlFilePickerChange():................End.\n");
}

function xmldsigffext_htmldsig_handleHtmlFileSourceChange(aHtmlInputSourceGroupElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleHtmlFileSourceChange():................Start.\n");

    gHtmlInputDocURIElem.value = "";

    gHtmlDSigInputFileIsSignedElem.checked = false;
    gHtmlDSigInputFileIsSignedElem.hidden = true;

    var htmlInputRefURIHboxElem = document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.refuri.hbox");
    if ((gHtmlInputFileURIElem.value == "") && !gHtmlInputFilePickerElem.file) {
	dump("Input HTML document source info is missing.\n");
	htmlInputRefURIHboxElem.hidden = true;
    	xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputDocURIElem);
    	return;
    }
    htmlInputRefURIHboxElem.hidden = false;

    if (gHtmlInputFilePickerElem.file && (gHtmlInputRefURIElem.value == "")) {
	dump("Reference URI missing for File path option.\n");
    	xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputDocURIElem);
    	return;
    }

    var htmlInputFileVBoxElem	= document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.in.file.vbox"); 
    gHtmlInputFileURIHboxElem.hidden = false;
    htmlInputFileVBoxElem.hidden = false;

    if (gHtmlInputFileURIElem.value != "") {
    	gHtmlInputDocURIElem.value = gHtmlInputFileURIElem.value;
    	htmlInputFileVBoxElem.hidden = true;
    }
    else if (gHtmlInputFilePickerElem.file) {
    	gHtmlInputFileURIHboxElem.hidden = true;
    	gHtmlInputDocURIElem.value = gHtmlInputFilePickerElem.fileuri;
    }

    if (gHtmlInputFilePickerElem.file && gHtmlInputRefURIElem.value != "") {
    	gHtmlDSigSignCmdElem.checked = true;
    	xmldsigffext_htmldsig_handleSignCmdChange(gHtmlDSigSignCmdElem);
    }

    xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputDocURIElem);

    // dump("xmldsigffext_htmldsig_handleHtmlFileSourceChange():................End.\n");
}

/*
function xmldsigffext_htmldsig_handleHtmlInputOptionChange(aHtmlInputOptionGroupElem, ev)
{
    dump("xmldsigffext_htmldsig_handleHtmlInputOptionChange():................Start.\n");

    if (aHtmlInputOptionGroupElem.selectedItem.value == "file") {
	gHtmlInputFilePickerElem.disabled = false;
	gHtmlInputFileURIElem.disabled = true;
    	xmldsigffext_htmldsig_handleHtmlFilePickerChange(gHtmlInputFilePickerElem);
    }
    else {
	gHtmlInputFilePickerElem.disabled = true;
	gHtmlInputFilePickerElem.value = "";
	gHtmlInputFileURIElem.disabled = false;
    	xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputFileURIElem);
    }

    dump("xmldsigffext_htmldsig_handleHtmlInputOptionChange():................End.\n");
}
*/

function xmldsigffext_htmldsig_handleSignCmdChange(aSignCmdOptionElem, ev)
{
    // dump("xmldsigffext_htmldsig_handleSignCmdChange():................Start.\n");

    var htmlInputRefURIHboxElem = document.getElementById("xmldsigffext.htmldsig.form.sign.htmldoc.refuri.hbox");
    if (aSignCmdOptionElem.checked) {
    	// gHtmlDSigProfileTypeMenuElem.disabled = false;
    	gHtmlDSigProfileTypeMenuElem.removeAttribute("disabled");
	htmlInputRefURIHboxElem.hidden = false;
	gHtmlDSigOutAutoSelectElem.hidden = false;
    }
    else {
    	// gHtmlDSigProfileTypeMenuElem.disabled = true;
    	gHtmlDSigProfileTypeMenuElem.setAttribute("disabled", true);
	htmlInputRefURIHboxElem.hidden = true;
	gHtmlDSigOutAutoSelectElem.hidden = true;
    }

    if (ev) {
    	xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputDocURIElem);
    }


    // dump("xmldsigffext_htmldsig_handleSignCmdChange():................End.\n");
}

function xmldsigffext_htmldsig_handleSigProfileTypeChange(aSigProfileTypeMenuElem, ev)
{
    xmldsigffext_htmldsig_handleHtmlDocURIChange(gHtmlInputDocURIElem);
}

function xmldsigffext_htmldsig_handleOutFileAutoSelectChange(aHtmlDSigOutAutoSelectElem, ev)
{
    if (!aHtmlDSigOutAutoSelectElem.checked) {
    	return;
    }
    xmldsigffext_htmldsig_autoSelectOutFiles();
}


function xmldsigffext_htmldsig_setInputHTMLFileURI(xmlFilePath)
{
    gHtmlInputFileURIElem.value = xmlFilePath;
}

function xmldsigffext_htmldsig_autoSelectOutSigXmlFile(aInHtmlFileBaseName)
{
    var outSigXmlFileName = aInHtmlFileBaseName + "_Sig.xml";

    // Select path to the signed XML File 
    var /* nsILocalFile */ outSignedXmlDocFile = null;
    if (gHtmlInputFilePickerElem.file) {
	outSignedXmlDocFile = gHtmlInputFilePickerElem.file.parent.clone();
	outSignedXmlDocFile.append(outSigXmlFileName);
	gHtmlDSigXmlOutFilePickerElem.filepath = outSignedXmlDocFile.path;
    }
    else {
	outSignedXmlDocFile =  xmldsigffext_autoSelectOutFile(gHtmlDSigXmlOutFilePickerElem, outSigXmlFileName);
    }
    if (gHtmlDSigXmlOutFilePickerElem.file == null) {
    	dump("xmldsigffext_htmldsig_autoSelectOutSigXmlFile(): failed to get outSignedXmlDocFile.\n");
        return null;
    }
    // dump("xmldsigffext_htmldsig_autoSelectOutSigXmlFile(): outSignedXmlDocFile: " + gHtmlDSigXmlOutFilePickerElem.filepath + "\n");

    return gHtmlDSigXmlOutFilePickerElem.file;
}

function xmldsigffext_htmldsig_autoSelectOutHtmlFile(aInHtmlFileName)
{
    var outHtmlFileName = "Signed_" + aInHtmlFileName;

    var /* nsILocalFile */ outSignedHtmlDocFile = null;
    if (gHtmlInputFilePickerElem.file) {
	outSignedHtmlDocFile = gHtmlInputFilePickerElem.file.parent.clone();
	outSignedHtmlDocFile.append(outHtmlFileName);
	gHtmlDSigHtmlOutFilePickerElem.filepath = outSignedHtmlDocFile.path;
    }
    else {
    	outSignedHtmlDocFile =  xmldsigffext_autoSelectOutFile(gHtmlDSigHtmlOutFilePickerElem, outHtmlFileName);
    }
    if (gHtmlDSigHtmlOutFilePickerElem.file == null) {
    	dump("xmldsigffext_htmldsig_autoSelectOutHtmlFile(): failed to get outSignedHtmlDocFile.\n");
        return null;
    }
    // dump("xmldsigffext_htmldsig_autoSelectOutHtmlFile(): outSignedHtmlDocFile: " + gHtmlDSigHtmlOutFilePickerElem.filepath + "\n");
    return gHtmlDSigHtmlOutFilePickerElem.file;
}


function xmldsigffext_htmldsig_autoSelectOutFiles()
{
    // dump("xmldsigffext_htmldsig_autoSelectOutFiles():................Start.\n");

    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService);
    var htmlDocURISpec = gHtmlInputDocURIElem.value;
    var htmlDocURI = ioService.newURI(htmlDocURISpec, null, null);

    var htmlDocURL = htmlDocURI.QueryInterface(Components.interfaces.nsIURL);
    var inputHtmlFileBaseName = htmlDocURL.fileBaseName;
    if (inputHtmlFileBaseName == "") {
    	inputHtmlFileBaseName = "index";
    }
    var inputHtmlFileName = htmlDocURL.fileName;
    if (inputHtmlFileName == "") {
    	inputHtmlFileName = "index.html";
    }
    

    var outSigXmlDocFile = gHtmlDSigXmlOutFilePickerElem.file;
    if (!outSigXmlDocFile) {
    	outSigXmlDocFile = xmldsigffext_htmldsig_autoSelectOutSigXmlFile(inputHtmlFileBaseName);
    }
    if (!outSigXmlDocFile) {
    	dump("xmldsigffext_htmldsig_autoSelectOutHtmlFile(): failed to get outSigXmlDocFile.\n");
        return false;
    }
    var detachedSigXmlDocURIStr = gHtmlDSigXmlOutFilePickerElem.fileuri;

    var /* nsILocalFile */ outSignedHtmlDocFile = gHtmlDSigHtmlOutFilePickerElem.file;
    if (!gHtmlDSigHtmlOutFilePickerElem.file) {
	outSignedHtmlDocFile = xmldsigffext_htmldsig_autoSelectOutHtmlFile(inputHtmlFileName);
    }
    if (outSignedHtmlDocFile == null) {
    	dump("xmldsigffext_htmldsig_autoSelectOutHtmlFile(): failed to get outSignedHtmlDocFile.\n");
        return false;
    }
    var outSignedHtmlDocURIStr = gHtmlDSigHtmlOutFilePickerElem.fileuri;

    // dump("xmldsigffext_htmldsig_autoSelectOutFiles():................End.\n");
    return true;
}

function xmldsigffext_htmldsig_enableForUnsignedXmlDoc()
{
    // dump("xmldsigffext_htmldsig_enableForUnsignedXmlDoc():................Start.\n");

    gHtmlDSigInputFileIsSignedElem.hidden = true;
    // gHtmlDSigProfileTypeMenuElem.disabled = false;
    gHtmlDSigProfileTypeMenuElem.removeAttribute("disabled");
    gHtmlDSigInputFileIsSignedElem.checked = false;

    xmldsigffext_htmldsig_showSignForm();

    gHtmlDSigSignedOutDocGridElem.hidden = false;

    // dump("xmldsigffext_htmldsig_enableForUnsignedXmlDoc():................End.\n");
}


function xmldsigffext_htmldsig_enableForSignedXmlDoc()
{
    // dump("xmldsigffext_htmldsig_enableForSignedXmlDoc():................Start.\n");

    gHtmlDSigInputFileIsSignedElem.hidden = false;
    // gHtmlDSigProfileTypeMenuElem.disabled = true;
    gHtmlDSigProfileTypeMenuElem.setAttribute("disabled", true);
    gHtmlDSigInputFileIsSignedElem.checked = true;

   xmldsigffext_htmldsig_showVerifyForm();

    gHtmlDSigSignedOutDocGridElem.hidden = true;

    // dump("xmldsigffext_htmldsig_enableForSignedXmlDoc():................End.\n");
}


function xmldsigffext_htmldsig_displayHtmlDocURI(aHtmlDocURISpec)
{
    // dump("xmldsigffext_htmldsig_displayHtmlDocURI():................Start.\n");

    gHtmlDSigEditorGBoxElem.hidden = true;

    if (!aHtmlDocURISpec || (aHtmlDocURISpec == "")) {
    	return;
    }

    
    if (gHtmlDSigOutAutoSelectElem.checked) {
        var retVal = xmldsigffext_htmldsig_autoSelectOutFiles();
        if (!retVal) {
    	    dump("Failed to auto-select output files.\n");
	    // return;
        }
    }


    gHtmlDSigEditorGBoxElem.hidden = false;

    var htmlSigProfile = gHtmlDSigProfileTypeMenuElem.value;
    var targetHtmlFileURISpec = gHtmlInputRefURIElem.value;
    var detachedSigXmlDocURIStr = null;

    try {
    	gHtmlDSigEditorElem.loadHtmlDocSignature(
			gHtmlDSigSignCmdElem.checked,
			aHtmlDocURISpec,
			htmlSigProfile,
			targetHtmlFileURISpec,
			detachedSigXmlDocURIStr
			);
    } catch (ex) {
    	dump("xmldsigffext_htmldsig_displayHtmlDocURI(): gHtmlDSigEditorElem.loadHtmlDocSignature() failed - ex: " + ex + "\n");
    	alert("xmldsigffext_htmldsig_displayHtmlDocURI(): failed to create/load XML digital signature.\n");
    	gHtmlDSigEditorGBoxElem.hidden = true;
	return;
    }

    var isSignedHtmlDoc = gHtmlDSigEditorElem.isSignedHtmlDoc;
    var isSignedXmlDoc = gHtmlDSigEditorElem.isSignedXmlDoc;
    // dump("xmldsigffext_htmldsig_displayHtmlDocURI(): isSignedHTMLDoc: " + isSignedHtmlDoc + "\n");
    // dump("xmldsigffext_htmldsig_displayHtmlDocURI(): isSignedXmlDoc: " + isSignedXmlDoc + "\n");

    if (!gHtmlDSigSignCmdElem.checked && isSignedHtmlDoc) {
    	xmldsigffext_htmldsig_enableForSignedXmlDoc();
	var credentialType = gHtmlDSigEditorElem.credentialType;
    	// dump("xmldsigffext_htmldsig_displayHtmlDocURI(): credentialType: " + credentialType + "\n");
	if ("certificate" == credentialType) {
	    var isUserCert = false;
	    var signerCert = gHtmlDSigEditorElem.docSignerCert;
	    if (signerCert) {
	    	isUserCert = gX509CertDBUtil.isUserCert(signerCert);
    	    	// dump("xmldsigffext_htmldsig_displayHtmlDocURI(): signerCert: " + signerCert.nickname + " isUserCert: " + isUserCert + "\n");
	    }
	}
	else {
	    gHtmlDSigEditorElem.signerSharedKey = "";
	}
	gHtmlDSigXmlOutFilePickerElem.value = "";
	gHtmlDSigHtmlOutFilePickerElem.value = "";

    }
    else {
    	xmldsigffext_htmldsig_enableForUnsignedXmlDoc();
    }
    gHtmlDSigProfileTypeMenuElem.value = gHtmlDSigEditorElem.htmlDocSigProfile;
    htmlSigProfile = gHtmlDSigEditorElem.htmlDocSigProfile;
    // dump("xmldsigffext_htmldsig_displayHtmlDocURI(): htmlSigProfile: " + htmlSigProfile + "\n");

    // dump("xmldsigffext_htmldsig_displayHtmlDocURI():................End.\n");
}

function xmldsigffext_htmldsig_loadAndVerifySignatureXmlDoc()
{
    // dump("xmldsigffext_htmldsig_loadAndVerifySignatureXmlDoc():................Start.\n");

    var htmlDocSignatureFilePath = gHtmlDSigXmlOutFilePickerElem.filepath;

    var argc = 0;
    var params = Components.classes["@mozilla.org/embedcomp/dialogparam;1"].
                        createInstance(Components.interfaces.nsIDialogParamBlock);
    params.SetString(argc, htmlDocSignatureFilePath); argc++;
    // params.SetString(argc, signedXmlDocFilePath); argc++;
    params.SetInt(0, argc);
    /*
    window.openDialog('chrome://xmldsigffext/content/XmlDSigToolForm.xul',
                             '_blank', 'chrome,centerscreen,resizable,modal,titlebar', params);
    */
    window.openDialog('chrome://xmldsigffext/content/xmldsig/XmlDigitalSigTool.xul',
                        '_blank', 'chrome,centerscreen,resizable,modal,titlebar', params);

    var retVal = params.GetInt(0);
    if (retVal == 0) {
        return;
    }

    // dump("xmldsigffext_htmldsig_loadAndVerifySignatureXmlDoc():................End.\n");
}

function xmldsigffext_htmldsig_loadAndVerifySignedHtmlDoc()
{
    // dump("xmldsigffext_htmldsig_loadAndVerifySignedHtmlDoc():................Start.\n");

    var outHtmlFileURIStr = gHtmlDSigHtmlOutFilePickerElem.fileuri;
    // dump("xmldsigffext_htmldsig_loadAndVerifySignedHtmlDoc(): outHtmlFileURIStr: " + outHtmlFileURIStr + "\n");


    xmldsigffext_htmldsig_resetInputFileSourceForm();

    gHtmlInputFileURIElem.value = outHtmlFileURIStr;
    xmldsigffext_htmldsig_handleHtmlFileURIChange(gHtmlInputFileURIElem);

    xmldsigffext_htmldsig_handleHtmlFileSourceChange(gHtmlInputSourceGroupElem);

    // gHtmlDSigXmlOutFilePickerElem.value = "";
    // gHtmlDSigHtmlOutFilePickerElem.value = "";

    // dump("xmldsigffext_htmldsig_loadAndVerifySignedHtmlDoc():................End.\n");
}

