
/*
pref("signed.applets.codebase_principal_support.x", true);
pref("browser.dom.window.dump.enabled.x", true);
pref("javascript.options.showInConsole.x", true);
*/

pref("xmldsigffext.useOldVersion", false);
pref("xmldsigffext.test", false);

pref("xmldsigffext.sign.signatureType", "ENVELOPED_SIGNATURE");
// pref("xmldsigffext.sign.signatureType", "ENVELOPING_SIGNATURE");
pref("xmldsigffext.sign.credentialType", "certificate");
pref("xmldsigffext.sign.canonicalizationMethodName", "C14NE_NOC");
pref("xmldsigffext.sign.signatureMethod", "http://www.w3.org/2000/09/xmldsig#rsa-sha1");
pref("xmldsigffext.sign.signatureMethod.symkey", "http://www.w3.org/2000/09/xmldsig#hmac-sha1");
// pref("xmldsigffext.sign.signerX509CertNickName", "");
pref("xmldsigffext.sign.keyinfo.KeyName", true);
pref("xmldsigffext.sign.keyinfo.KeyValue", true);
pref("xmldsigffext.sign.keyinfo.X509SubjectName", true);
pref("xmldsigffext.sign.keyinfo.X509Certificate", true);

pref("xmldsigffext.sign.wizardWorkFlowSeq", "sign,verify");
// pref("xmldsigffext.sign.inputXMLFilePath", "");
// pref("xmldsigffext.sign.outputXMLFilePath", "");

pref("xmldsigffext.encrypt.symkey.enc.algorithm", "http://www.w3.org/2001/04/xmlenc#tripledes-cbc");
pref("xmldsigffext.encrypt.kek.enc.algorithm", "http://www.w3.org/2001/04/xmlenc#rsa-1_5");
pref("xmldsigffext.signenc.keyinfo.X509Certificate", true);
pref("xmldsigffext.signenc.keyinfo.X509SHA1Fingerprint", true);

pref("xmldsigffext.samltok.wizardWorkFlowSeq", "create,sign");
pref("xmldsigffext.samltok.create.credentialType", "certificiate");
pref("xmldsigffext.samltok.saml.version", "samlv2");
pref("xmldsigffext.samltok.attribute.profile", "samlv2Basic");
pref("xmldsigffext.samltok.subject.proofkey", true);
pref("xmldsigffext.samltok.subject.keyinfo.KeyName", true);
pref("xmldsigffext.samltok.subject.keyinfo.X509SHA1Fingerprint", true);
pref("xmldsigffext.samltok.subject.keyinfo.X509Certificate", true);
pref("xmldsigffext.samltok.sign.signatureType", "ENVELOPED_SIGNATURE");
pref("xmldsigffext.samltok.sign.canonicalizationMethodName", "C14NE_NOC");
pref("xmldsigffext.samltok.sign.signatureMethod", "http://www.w3.org/2000/09/xmldsig#rsa-sha1");
pref("xmldsigffext.samltok.sign.signatureMethod.symkey", "http://www.w3.org/2000/09/xmldsig#hmac-sha1");
pref("xmldsigffext.samltok.sign.keyinfo.KeyName", true);
pref("xmldsigffext.samltok.sign.keyinfo.KeyValue", true);
pref("xmldsigffext.samltok.sign.keyinfo.X509SHA1Fingerprint", true);
pref("xmldsigffext.samltok.sign.keyinfo.X509keyidentifier", true);
pref("xmldsigffext.samltok.sign.keyinfo.X509Certificate", true);
// pref("xmldsigffext.samltok.sign.signerX509CertNickName", "");
pref("xmldsigffext.samltok.symkey.enc.algorithm", "http://www.w3.org/2001/04/xmlenc#tripledes-cbc");
pref("xmldsigffext.samltok.kek.enc.algorithm", "http://www.w3.org/2001/04/xmlenc#rsa-1_5");
pref("xmldsigffext.samltok.kek.keyinfo.X509Certificate", true);
pref("xmldsigffext.samltok.kek.keyinfo.X509SHA1Fingerprint", true);

pref("xmldsigffext.htmldsig.enable", false);
pref("xmldsigffext.htmldsig.proxy.override", false);
pref("xmldsigffext.htmldsig.validation.enable", false);
pref("xmldsigffext.htmldsig.sign.signatureProfile", "dsig-full");
pref("xmldsigffext.htmldsig.sign.signatureType", "DETACHED_SIGNATURE");
pref("xmldsigffext.htmldsig.sign.credentialType", "certificate");
// pref("xmldsigffext.htmldsig.sign.signerX509CertNickName", "");
pref("xmldsigffext.htmldsig.sign.canonicalizationMethodName", "C14N_NOC");
pref("xmldsigffext.htmldsig.sign.canonicalizationMethod", "http://www.w3.org/TR/2001/REC-xml-c14n-20010315");
pref("xmldsigffext.htmldsig.sign.signatureMethod", "http://www.w3.org/2000/09/xmldsig#rsa-sha1");
pref("xmldsigffext.htmldsig.sign.keyinfo.X509Certificate", true);

